// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`UpdateDataRetention`](crate::operation::update_data_retention::builders::UpdateDataRetentionFluentBuilder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`stream_name(impl Into<String>)`](crate::operation::update_data_retention::builders::UpdateDataRetentionFluentBuilder::stream_name) / [`set_stream_name(Option<String>)`](crate::operation::update_data_retention::builders::UpdateDataRetentionFluentBuilder::set_stream_name):<br>required: **false**<br><p>The name of the stream whose retention period you want to change.</p><br>
    ///   - [`stream_arn(impl Into<String>)`](crate::operation::update_data_retention::builders::UpdateDataRetentionFluentBuilder::stream_arn) / [`set_stream_arn(Option<String>)`](crate::operation::update_data_retention::builders::UpdateDataRetentionFluentBuilder::set_stream_arn):<br>required: **false**<br><p>The Amazon Resource Name (ARN) of the stream whose retention period you want to change.</p><br>
    ///   - [`current_version(impl Into<String>)`](crate::operation::update_data_retention::builders::UpdateDataRetentionFluentBuilder::current_version) / [`set_current_version(Option<String>)`](crate::operation::update_data_retention::builders::UpdateDataRetentionFluentBuilder::set_current_version):<br>required: **true**<br><p>The version of the stream whose retention period you want to change. To get the version, call either the <code>DescribeStream</code> or the <code>ListStreams</code> API.</p><br>
    ///   - [`operation(UpdateDataRetentionOperation)`](crate::operation::update_data_retention::builders::UpdateDataRetentionFluentBuilder::operation) / [`set_operation(Option<UpdateDataRetentionOperation>)`](crate::operation::update_data_retention::builders::UpdateDataRetentionFluentBuilder::set_operation):<br>required: **true**<br><p>Indicates whether you want to increase or decrease the retention period.</p><br>
    ///   - [`data_retention_change_in_hours(i32)`](crate::operation::update_data_retention::builders::UpdateDataRetentionFluentBuilder::data_retention_change_in_hours) / [`set_data_retention_change_in_hours(Option<i32>)`](crate::operation::update_data_retention::builders::UpdateDataRetentionFluentBuilder::set_data_retention_change_in_hours):<br>required: **true**<br><p>The number of hours to adjust the current retention by. The value you specify is added to or subtracted from the current value, depending on the <code>operation</code>.</p> <p>The minimum value for data retention is 0 and the maximum value is 87600 (ten years).</p><br>
    /// - On success, responds with [`UpdateDataRetentionOutput`](crate::operation::update_data_retention::UpdateDataRetentionOutput)
    /// - On failure, responds with [`SdkError<UpdateDataRetentionError>`](crate::operation::update_data_retention::UpdateDataRetentionError)
    pub fn update_data_retention(&self) -> crate::operation::update_data_retention::builders::UpdateDataRetentionFluentBuilder {
        crate::operation::update_data_retention::builders::UpdateDataRetentionFluentBuilder::new(self.handle.clone())
    }
}
