// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::fmt::Debug)]
pub struct ListStreamsOutput {
    /// <p>An array of <code>StreamInfo</code> objects.</p>
    pub stream_info_list: ::std::option::Option<::std::vec::Vec<crate::types::StreamInfo>>,
    /// <p>If the response is truncated, the call returns this element with a token. To get the next batch of streams, use this token in your next request.</p>
    pub next_token: ::std::option::Option<::std::string::String>,
    _request_id: Option<String>,
}
impl ListStreamsOutput {
    /// <p>An array of <code>StreamInfo</code> objects.</p>
    ///
    /// If no value was sent for this field, a default will be set. If you want to determine if no value was sent, use `.stream_info_list.is_none()`.
    pub fn stream_info_list(&self) -> &[crate::types::StreamInfo] {
        self.stream_info_list.as_deref().unwrap_or_default()
    }
    /// <p>If the response is truncated, the call returns this element with a token. To get the next batch of streams, use this token in your next request.</p>
    pub fn next_token(&self) -> ::std::option::Option<&str> {
        self.next_token.as_deref()
    }
}
impl ::aws_types::request_id::RequestId for ListStreamsOutput {
    fn request_id(&self) -> Option<&str> {
        self._request_id.as_deref()
    }
}
impl ListStreamsOutput {
    /// Creates a new builder-style object to manufacture [`ListStreamsOutput`](crate::operation::list_streams::ListStreamsOutput).
    pub fn builder() -> crate::operation::list_streams::builders::ListStreamsOutputBuilder {
        crate::operation::list_streams::builders::ListStreamsOutputBuilder::default()
    }
}

/// A builder for [`ListStreamsOutput`](crate::operation::list_streams::ListStreamsOutput).
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::default::Default, ::std::fmt::Debug)]
pub struct ListStreamsOutputBuilder {
    pub(crate) stream_info_list: ::std::option::Option<::std::vec::Vec<crate::types::StreamInfo>>,
    pub(crate) next_token: ::std::option::Option<::std::string::String>,
    _request_id: Option<String>,
}
impl ListStreamsOutputBuilder {
    /// Appends an item to `stream_info_list`.
    ///
    /// To override the contents of this collection use [`set_stream_info_list`](Self::set_stream_info_list).
    ///
    /// <p>An array of <code>StreamInfo</code> objects.</p>
    pub fn stream_info_list(mut self, input: crate::types::StreamInfo) -> Self {
        let mut v = self.stream_info_list.unwrap_or_default();
        v.push(input);
        self.stream_info_list = ::std::option::Option::Some(v);
        self
    }
    /// <p>An array of <code>StreamInfo</code> objects.</p>
    pub fn set_stream_info_list(mut self, input: ::std::option::Option<::std::vec::Vec<crate::types::StreamInfo>>) -> Self {
        self.stream_info_list = input;
        self
    }
    /// <p>An array of <code>StreamInfo</code> objects.</p>
    pub fn get_stream_info_list(&self) -> &::std::option::Option<::std::vec::Vec<crate::types::StreamInfo>> {
        &self.stream_info_list
    }
    /// <p>If the response is truncated, the call returns this element with a token. To get the next batch of streams, use this token in your next request.</p>
    pub fn next_token(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.next_token = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>If the response is truncated, the call returns this element with a token. To get the next batch of streams, use this token in your next request.</p>
    pub fn set_next_token(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.next_token = input;
        self
    }
    /// <p>If the response is truncated, the call returns this element with a token. To get the next batch of streams, use this token in your next request.</p>
    pub fn get_next_token(&self) -> &::std::option::Option<::std::string::String> {
        &self.next_token
    }
    pub(crate) fn _request_id(mut self, request_id: impl Into<String>) -> Self {
        self._request_id = Some(request_id.into());
        self
    }

    pub(crate) fn _set_request_id(&mut self, request_id: Option<String>) -> &mut Self {
        self._request_id = request_id;
        self
    }
    /// Consumes the builder and constructs a [`ListStreamsOutput`](crate::operation::list_streams::ListStreamsOutput).
    pub fn build(self) -> crate::operation::list_streams::ListStreamsOutput {
        crate::operation::list_streams::ListStreamsOutput {
            stream_info_list: self.stream_info_list,
            next_token: self.next_token,
            _request_id: self._request_id,
        }
    }
}
