// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.

/// <p>The latest status of a stream's edge recording job.</p>
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::fmt::Debug)]
pub struct LastRecorderStatus {
    /// <p>A description of a recorder job’s latest status.</p>
    pub job_status_details: ::std::option::Option<::std::string::String>,
    /// <p>The timestamp at which the recorder job was last executed and media stored to local disk.</p>
    pub last_collected_time: ::std::option::Option<::aws_smithy_types::DateTime>,
    /// <p>The timestamp at which the recorder status was last updated.</p>
    pub last_updated_time: ::std::option::Option<::aws_smithy_types::DateTime>,
    /// <p>The status of the latest recorder job.</p>
    pub recorder_status: ::std::option::Option<crate::types::RecorderStatus>,
}
impl LastRecorderStatus {
    /// <p>A description of a recorder job’s latest status.</p>
    pub fn job_status_details(&self) -> ::std::option::Option<&str> {
        self.job_status_details.as_deref()
    }
    /// <p>The timestamp at which the recorder job was last executed and media stored to local disk.</p>
    pub fn last_collected_time(&self) -> ::std::option::Option<&::aws_smithy_types::DateTime> {
        self.last_collected_time.as_ref()
    }
    /// <p>The timestamp at which the recorder status was last updated.</p>
    pub fn last_updated_time(&self) -> ::std::option::Option<&::aws_smithy_types::DateTime> {
        self.last_updated_time.as_ref()
    }
    /// <p>The status of the latest recorder job.</p>
    pub fn recorder_status(&self) -> ::std::option::Option<&crate::types::RecorderStatus> {
        self.recorder_status.as_ref()
    }
}
impl LastRecorderStatus {
    /// Creates a new builder-style object to manufacture [`LastRecorderStatus`](crate::types::LastRecorderStatus).
    pub fn builder() -> crate::types::builders::LastRecorderStatusBuilder {
        crate::types::builders::LastRecorderStatusBuilder::default()
    }
}

/// A builder for [`LastRecorderStatus`](crate::types::LastRecorderStatus).
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::default::Default, ::std::fmt::Debug)]
pub struct LastRecorderStatusBuilder {
    pub(crate) job_status_details: ::std::option::Option<::std::string::String>,
    pub(crate) last_collected_time: ::std::option::Option<::aws_smithy_types::DateTime>,
    pub(crate) last_updated_time: ::std::option::Option<::aws_smithy_types::DateTime>,
    pub(crate) recorder_status: ::std::option::Option<crate::types::RecorderStatus>,
}
impl LastRecorderStatusBuilder {
    /// <p>A description of a recorder job’s latest status.</p>
    pub fn job_status_details(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.job_status_details = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>A description of a recorder job’s latest status.</p>
    pub fn set_job_status_details(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.job_status_details = input;
        self
    }
    /// <p>A description of a recorder job’s latest status.</p>
    pub fn get_job_status_details(&self) -> &::std::option::Option<::std::string::String> {
        &self.job_status_details
    }
    /// <p>The timestamp at which the recorder job was last executed and media stored to local disk.</p>
    pub fn last_collected_time(mut self, input: ::aws_smithy_types::DateTime) -> Self {
        self.last_collected_time = ::std::option::Option::Some(input);
        self
    }
    /// <p>The timestamp at which the recorder job was last executed and media stored to local disk.</p>
    pub fn set_last_collected_time(mut self, input: ::std::option::Option<::aws_smithy_types::DateTime>) -> Self {
        self.last_collected_time = input;
        self
    }
    /// <p>The timestamp at which the recorder job was last executed and media stored to local disk.</p>
    pub fn get_last_collected_time(&self) -> &::std::option::Option<::aws_smithy_types::DateTime> {
        &self.last_collected_time
    }
    /// <p>The timestamp at which the recorder status was last updated.</p>
    pub fn last_updated_time(mut self, input: ::aws_smithy_types::DateTime) -> Self {
        self.last_updated_time = ::std::option::Option::Some(input);
        self
    }
    /// <p>The timestamp at which the recorder status was last updated.</p>
    pub fn set_last_updated_time(mut self, input: ::std::option::Option<::aws_smithy_types::DateTime>) -> Self {
        self.last_updated_time = input;
        self
    }
    /// <p>The timestamp at which the recorder status was last updated.</p>
    pub fn get_last_updated_time(&self) -> &::std::option::Option<::aws_smithy_types::DateTime> {
        &self.last_updated_time
    }
    /// <p>The status of the latest recorder job.</p>
    pub fn recorder_status(mut self, input: crate::types::RecorderStatus) -> Self {
        self.recorder_status = ::std::option::Option::Some(input);
        self
    }
    /// <p>The status of the latest recorder job.</p>
    pub fn set_recorder_status(mut self, input: ::std::option::Option<crate::types::RecorderStatus>) -> Self {
        self.recorder_status = input;
        self
    }
    /// <p>The status of the latest recorder job.</p>
    pub fn get_recorder_status(&self) -> &::std::option::Option<crate::types::RecorderStatus> {
        &self.recorder_status
    }
    /// Consumes the builder and constructs a [`LastRecorderStatus`](crate::types::LastRecorderStatus).
    pub fn build(self) -> crate::types::LastRecorderStatus {
        crate::types::LastRecorderStatus {
            job_status_details: self.job_status_details,
            last_collected_time: self.last_collected_time,
            last_updated_time: self.last_updated_time,
            recorder_status: self.recorder_status,
        }
    }
}
