// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.

/// <p>The latest status of a stream’s edge to cloud uploader job.</p>
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::fmt::Debug)]
pub struct LastUploaderStatus {
    /// <p>A description of an uploader job’s latest status.</p>
    pub job_status_details: ::std::option::Option<::std::string::String>,
    /// <p>The timestamp at which the uploader job was last executed and media collected to the cloud.</p>
    pub last_collected_time: ::std::option::Option<::aws_smithy_types::DateTime>,
    /// <p>The timestamp at which the uploader status was last updated.</p>
    pub last_updated_time: ::std::option::Option<::aws_smithy_types::DateTime>,
    /// <p>The status of the latest uploader job.</p>
    pub uploader_status: ::std::option::Option<crate::types::UploaderStatus>,
}
impl LastUploaderStatus {
    /// <p>A description of an uploader job’s latest status.</p>
    pub fn job_status_details(&self) -> ::std::option::Option<&str> {
        self.job_status_details.as_deref()
    }
    /// <p>The timestamp at which the uploader job was last executed and media collected to the cloud.</p>
    pub fn last_collected_time(&self) -> ::std::option::Option<&::aws_smithy_types::DateTime> {
        self.last_collected_time.as_ref()
    }
    /// <p>The timestamp at which the uploader status was last updated.</p>
    pub fn last_updated_time(&self) -> ::std::option::Option<&::aws_smithy_types::DateTime> {
        self.last_updated_time.as_ref()
    }
    /// <p>The status of the latest uploader job.</p>
    pub fn uploader_status(&self) -> ::std::option::Option<&crate::types::UploaderStatus> {
        self.uploader_status.as_ref()
    }
}
impl LastUploaderStatus {
    /// Creates a new builder-style object to manufacture [`LastUploaderStatus`](crate::types::LastUploaderStatus).
    pub fn builder() -> crate::types::builders::LastUploaderStatusBuilder {
        crate::types::builders::LastUploaderStatusBuilder::default()
    }
}

/// A builder for [`LastUploaderStatus`](crate::types::LastUploaderStatus).
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::default::Default, ::std::fmt::Debug)]
pub struct LastUploaderStatusBuilder {
    pub(crate) job_status_details: ::std::option::Option<::std::string::String>,
    pub(crate) last_collected_time: ::std::option::Option<::aws_smithy_types::DateTime>,
    pub(crate) last_updated_time: ::std::option::Option<::aws_smithy_types::DateTime>,
    pub(crate) uploader_status: ::std::option::Option<crate::types::UploaderStatus>,
}
impl LastUploaderStatusBuilder {
    /// <p>A description of an uploader job’s latest status.</p>
    pub fn job_status_details(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.job_status_details = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>A description of an uploader job’s latest status.</p>
    pub fn set_job_status_details(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.job_status_details = input;
        self
    }
    /// <p>A description of an uploader job’s latest status.</p>
    pub fn get_job_status_details(&self) -> &::std::option::Option<::std::string::String> {
        &self.job_status_details
    }
    /// <p>The timestamp at which the uploader job was last executed and media collected to the cloud.</p>
    pub fn last_collected_time(mut self, input: ::aws_smithy_types::DateTime) -> Self {
        self.last_collected_time = ::std::option::Option::Some(input);
        self
    }
    /// <p>The timestamp at which the uploader job was last executed and media collected to the cloud.</p>
    pub fn set_last_collected_time(mut self, input: ::std::option::Option<::aws_smithy_types::DateTime>) -> Self {
        self.last_collected_time = input;
        self
    }
    /// <p>The timestamp at which the uploader job was last executed and media collected to the cloud.</p>
    pub fn get_last_collected_time(&self) -> &::std::option::Option<::aws_smithy_types::DateTime> {
        &self.last_collected_time
    }
    /// <p>The timestamp at which the uploader status was last updated.</p>
    pub fn last_updated_time(mut self, input: ::aws_smithy_types::DateTime) -> Self {
        self.last_updated_time = ::std::option::Option::Some(input);
        self
    }
    /// <p>The timestamp at which the uploader status was last updated.</p>
    pub fn set_last_updated_time(mut self, input: ::std::option::Option<::aws_smithy_types::DateTime>) -> Self {
        self.last_updated_time = input;
        self
    }
    /// <p>The timestamp at which the uploader status was last updated.</p>
    pub fn get_last_updated_time(&self) -> &::std::option::Option<::aws_smithy_types::DateTime> {
        &self.last_updated_time
    }
    /// <p>The status of the latest uploader job.</p>
    pub fn uploader_status(mut self, input: crate::types::UploaderStatus) -> Self {
        self.uploader_status = ::std::option::Option::Some(input);
        self
    }
    /// <p>The status of the latest uploader job.</p>
    pub fn set_uploader_status(mut self, input: ::std::option::Option<crate::types::UploaderStatus>) -> Self {
        self.uploader_status = input;
        self
    }
    /// <p>The status of the latest uploader job.</p>
    pub fn get_uploader_status(&self) -> &::std::option::Option<crate::types::UploaderStatus> {
        &self.uploader_status
    }
    /// Consumes the builder and constructs a [`LastUploaderStatus`](crate::types::LastUploaderStatus).
    pub fn build(self) -> crate::types::LastUploaderStatus {
        crate::types::LastUploaderStatus {
            job_status_details: self.job_status_details,
            last_collected_time: self.last_collected_time,
            last_updated_time: self.last_updated_time,
            uploader_status: self.uploader_status,
        }
    }
}
