// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.

/// <p>A structure that encapsulates, or contains, the media storage configuration properties.</p>
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::fmt::Debug)]
pub struct MappedResourceConfigurationListItem {
    /// <p>The type of the associated resource for the kinesis video stream.</p>
    pub r#type: ::std::option::Option<::std::string::String>,
    /// <p>The Amazon Resource Name (ARN) of the Kinesis Video Stream resource, associated with the stream.</p>
    pub arn: ::std::option::Option<::std::string::String>,
}
impl MappedResourceConfigurationListItem {
    /// <p>The type of the associated resource for the kinesis video stream.</p>
    pub fn r#type(&self) -> ::std::option::Option<&str> {
        self.r#type.as_deref()
    }
    /// <p>The Amazon Resource Name (ARN) of the Kinesis Video Stream resource, associated with the stream.</p>
    pub fn arn(&self) -> ::std::option::Option<&str> {
        self.arn.as_deref()
    }
}
impl MappedResourceConfigurationListItem {
    /// Creates a new builder-style object to manufacture [`MappedResourceConfigurationListItem`](crate::types::MappedResourceConfigurationListItem).
    pub fn builder() -> crate::types::builders::MappedResourceConfigurationListItemBuilder {
        crate::types::builders::MappedResourceConfigurationListItemBuilder::default()
    }
}

/// A builder for [`MappedResourceConfigurationListItem`](crate::types::MappedResourceConfigurationListItem).
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::default::Default, ::std::fmt::Debug)]
pub struct MappedResourceConfigurationListItemBuilder {
    pub(crate) r#type: ::std::option::Option<::std::string::String>,
    pub(crate) arn: ::std::option::Option<::std::string::String>,
}
impl MappedResourceConfigurationListItemBuilder {
    /// <p>The type of the associated resource for the kinesis video stream.</p>
    pub fn r#type(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.r#type = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>The type of the associated resource for the kinesis video stream.</p>
    pub fn set_type(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.r#type = input;
        self
    }
    /// <p>The type of the associated resource for the kinesis video stream.</p>
    pub fn get_type(&self) -> &::std::option::Option<::std::string::String> {
        &self.r#type
    }
    /// <p>The Amazon Resource Name (ARN) of the Kinesis Video Stream resource, associated with the stream.</p>
    pub fn arn(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.arn = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>The Amazon Resource Name (ARN) of the Kinesis Video Stream resource, associated with the stream.</p>
    pub fn set_arn(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.arn = input;
        self
    }
    /// <p>The Amazon Resource Name (ARN) of the Kinesis Video Stream resource, associated with the stream.</p>
    pub fn get_arn(&self) -> &::std::option::Option<::std::string::String> {
        &self.arn
    }
    /// Consumes the builder and constructs a [`MappedResourceConfigurationListItem`](crate::types::MappedResourceConfigurationListItem).
    pub fn build(self) -> crate::types::MappedResourceConfigurationListItem {
        crate::types::MappedResourceConfigurationListItem {
            r#type: self.r#type,
            arn: self.arn,
        }
    }
}
